
;CodeVisionAVR C Compiler V2.05.3 Standard
;(C) Copyright 1998-2011 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATmega8
;Program type             : Application
;Clock frequency          : 8.000000 MHz
;Memory model             : Small
;Optimize for             : Size
;(s)printf features       : float, width, precision
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 256 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : Yes
;'char' is unsigned       : Yes
;8 bit enums              : Yes
;Global 'const' stored in FLASH     : No
;Enhanced function parameter passing: Yes
;Enhanced core instructions         : On
;Smart register allocation          : On
;Automatic register allocation      : On

	#pragma AVRPART ADMIN PART_NAME ATmega8
	#pragma AVRPART MEMORY PROG_FLASH 8192
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1119
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x0060
	.EQU __SRAM_END=0x045F
	.EQU __DSTACK_SIZE=0x0100
	.EQU __HEAP_SIZE=0x0000
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTW2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	LDI  R24,BYTE3(2*@0+(@1))
	LDI  R25,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _ac1=R4
	.DEF _ac2=R6
	.DEF _ac3=R8
	.DEF _b1=R10
	.DEF _b2=R12

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00

_0x0:
	.DB  0x20,0x20,0x43,0x41,0x4C,0x49,0x42,0x52
	.DB  0x41,0x54,0x49,0x4F,0x4E,0x0,0x41,0x43
	.DB  0x31,0x3D,0x20,0x25,0x64,0x0,0x41,0x43
	.DB  0x32,0x3D,0x20,0x25,0x64,0x0,0x41,0x43
	.DB  0x33,0x3D,0x20,0x25,0x64,0x0,0x41,0x43
	.DB  0x34,0x3D,0x20,0x25,0x64,0x0,0x41,0x43
	.DB  0x35,0x3D,0x20,0x25,0x64,0x0,0x41,0x43
	.DB  0x36,0x3D,0x20,0x25,0x64,0x0,0x42,0x31
	.DB  0x3D,0x20,0x25,0x64,0x0,0x42,0x32,0x3D
	.DB  0x20,0x25,0x64,0x0,0x4D,0x42,0x3D,0x20
	.DB  0x25,0x64,0x0,0x4D,0x43,0x3D,0x20,0x25
	.DB  0x64,0x0,0x4D,0x44,0x3D,0x20,0x25,0x64
	.DB  0x0,0x54,0x3D,0x20,0x25,0x64,0x2E,0x25
	.DB  0x64,0x20,0xDF,0x43,0x0,0x50,0x3D,0x20
	.DB  0x25,0x64,0x25,0x64,0x20,0x50,0x61,0x0
	.DB  0x42,0x4D,0x50,0x31,0x38,0x30,0x20,0x0
	.DB  0x50,0x72,0x65,0x73,0x73,0x75,0x72,0x65
	.DB  0x2F,0x54,0x65,0x6D,0x70,0x2E,0x2E,0x2E
	.DB  0x0
_0x2020003:
	.DB  0x80,0xC0
_0x2040000:
	.DB  0x2D,0x4E,0x41,0x4E,0x0
_0x2060060:
	.DB  0x1
_0x2060000:
	.DB  0x2D,0x4E,0x41,0x4E,0x0,0x49,0x4E,0x46
	.DB  0x0

__GLOBAL_INI_TBL:
	.DW  0x02
	.DW  __base_y_G101
	.DW  _0x2020003*2

	.DW  0x01
	.DW  __seed_G103
	.DW  _0x2060060*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(__CLEAR_SRAM_SIZE)
	LDI  R25,HIGH(__CLEAR_SRAM_SIZE)
	LDI  R26,__SRAM_START
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;HARDWARE STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30
	LDI  R30,HIGH(__SRAM_END-__HEAP_SIZE)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)
	LDI  R29,HIGH(__SRAM_START+__DSTACK_SIZE)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x160

	.CSEG
;#include <mega8.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;#include <math.h>
;#include <alcd.h>
;#include <delay.h>
;#include <stdio.h>
;#include <i2c.h>
;#asm
    .equ __i2c_port=0x15
    .equ __sda_bit=4
    .equ __scl_bit=5
; 0000 000B #endasm
;
;#define DEVICE_address_write        0xEE
;#define DEVICE_address_read         0xEF
;#define PT_writeAddress_register    0xF4
;#define PT_resultAddress_register   0xF6
;#define T_control_register          0x2E
;#define oss                         0
;#define P_control_register          (0x34+(oss<<6))
;#define P0                          101325
;#define ACK                         1
;#define NOACK                       0
;
;#define     AC1_add     0xAA
;#define     AC2_add     0xAC
;#define     AC3_add     0xAE
;#define     AC4_add     0xB0
;#define     AC5_add     0xB2
;#define     AC6_add     0xB4
;#define     B1_add      0xB6
;#define     B2_add      0xB8
;#define     MB_add      0xBA
;#define     MC_add      0xBC
;#define     MD_add      0xBE
;
;short int ac1,ac2,ac3,b1,b2,mb,md;
;unsigned short int ac4,ac5,ac6;
;long int mc;
;long   UT,UP,T,P,x1,x2,x3,b3,b5,b6;
;unsigned long int b4,b7;
;unsigned char data[2];
;int  n1,n2,temp_t1,temp_t2;
;char lcd_buf[17];
;
;///fffffffff
;////fffffffffffff
;
;
;void write_to_device(unsigned char address_register ,unsigned char control_register)
; 0000 0032   {

	.CSEG
_write_to_device:
; 0000 0033    i2c_start();
	RCALL SUBOPT_0x0
;	address_register -> Y+1
;	control_register -> Y+0
; 0000 0034    i2c_write(DEVICE_address_write);
; 0000 0035    i2c_write(address_register);
	LDD  R26,Y+1
	RCALL _i2c_write
; 0000 0036    i2c_write(control_register);
	LD   R26,Y
	RCALL _i2c_write
; 0000 0037    i2c_stop();
	RCALL _i2c_stop
; 0000 0038    }
	RJMP _0x20C0007
;
;void read_from_device(unsigned char address_register)
; 0000 003B   {
_read_from_device:
; 0000 003C    i2c_start();
	RCALL SUBOPT_0x0
;	address_register -> Y+0
; 0000 003D    i2c_write(DEVICE_address_write);
; 0000 003E    i2c_write(address_register);
	LD   R26,Y
	RCALL _i2c_write
; 0000 003F    i2c_start();
	RCALL _i2c_start
; 0000 0040    i2c_write(DEVICE_address_read);
	LDI  R26,LOW(239)
	RCALL _i2c_write
; 0000 0041    data[0]=i2c_read(ACK);
	LDI  R26,LOW(1)
	RCALL _i2c_read
	STS  _data,R30
; 0000 0042    data[1]=i2c_read(NOACK);
	LDI  R26,LOW(0)
	RCALL _i2c_read
	__PUTB1MN _data,1
; 0000 0043    i2c_stop();
	RCALL _i2c_stop
; 0000 0044   }
	RJMP _0x20C0005
;
;int power(int i , int j)
; 0000 0047  {
_power:
; 0000 0048 int k=0,r=1;
; 0000 0049  for(k=0;k<j;k++){
	RCALL SUBOPT_0x1
	RCALL __SAVELOCR4
;	i -> Y+6
;	j -> Y+4
;	k -> R16,R17
;	r -> R18,R19
	__GETWRN 16,17,0
	__GETWRN 18,19,1
	__GETWRN 16,17,0
_0x4:
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	CP   R16,R30
	CPC  R17,R31
	BRGE _0x5
; 0000 004A     r=r*i;
	RCALL SUBOPT_0x2
	MOVW R26,R18
	RCALL __MULW12
	MOVW R18,R30
; 0000 004B     }
	__ADDWRN 16,17,1
	RJMP _0x4
_0x5:
; 0000 004C  return r;
	MOVW R30,R18
	RCALL __LOADLOCR4
	ADIW R28,8
	RET
; 0000 004D  }
;
;void calibre(){
; 0000 004F void calibre(){
_calibre:
; 0000 0050 //********************************** CALIBRATION ************************************
; 0000 0051 read_from_device(AC1_add);
	LDI  R26,LOW(170)
	RCALL SUBOPT_0x3
; 0000 0052 ac1=(short int)(data[0]<<8)+data[1];
	MOVW R4,R30
; 0000 0053 lcd_clear();lcd_gotoxy(0,0);lcd_putsf("  CALIBRATION");
	RCALL SUBOPT_0x4
; 0000 0054 sprintf(lcd_buf,"AC1= %d",ac1);lcd_gotoxy(0,1); lcd_puts(lcd_buf); delay_ms(100);
	__POINTW1FN _0x0,14
	RCALL SUBOPT_0x5
	MOVW R30,R4
	RCALL SUBOPT_0x6
; 0000 0055 //...................................................................................
; 0000 0056 read_from_device(AC2_add);
	LDI  R26,LOW(172)
	RCALL SUBOPT_0x3
; 0000 0057 ac2=(short int)(data[0]<<8)+data[1];
	MOVW R6,R30
; 0000 0058 lcd_clear();lcd_gotoxy(0,0);lcd_putsf("  CALIBRATION");
	RCALL SUBOPT_0x4
; 0000 0059 sprintf(lcd_buf,"AC2= %d",ac2);lcd_gotoxy(0,1); lcd_puts(lcd_buf); delay_ms(100);
	__POINTW1FN _0x0,22
	RCALL SUBOPT_0x5
	MOVW R30,R6
	RCALL SUBOPT_0x6
; 0000 005A //...................................................................................
; 0000 005B read_from_device(AC3_add);
	LDI  R26,LOW(174)
	RCALL SUBOPT_0x3
; 0000 005C ac3=(short int)(data[0]<<8)+data[1];
	MOVW R8,R30
; 0000 005D lcd_clear();lcd_gotoxy(0,0);lcd_putsf("  CALIBRATION");
	RCALL SUBOPT_0x4
; 0000 005E sprintf(lcd_buf,"AC3= %d",ac3);lcd_gotoxy(0,1); lcd_puts(lcd_buf); delay_ms(100);
	__POINTW1FN _0x0,30
	RCALL SUBOPT_0x5
	MOVW R30,R8
	RCALL SUBOPT_0x6
; 0000 005F //...................................................................................
; 0000 0060 read_from_device(AC4_add);
	LDI  R26,LOW(176)
	RCALL SUBOPT_0x3
; 0000 0061 ac4=(unsigned short int)(data[0]<<8)+data[1];
	STS  _ac4,R30
	STS  _ac4+1,R31
; 0000 0062 lcd_clear();lcd_gotoxy(0,0);lcd_putsf("  CALIBRATION");
	RCALL SUBOPT_0x4
; 0000 0063 sprintf(lcd_buf,"AC4= %d",ac4);lcd_gotoxy(0,1); lcd_puts(lcd_buf); delay_ms(100);
	__POINTW1FN _0x0,38
	RCALL SUBOPT_0x5
	LDS  R30,_ac4
	LDS  R31,_ac4+1
	RCALL SUBOPT_0x7
; 0000 0064 //...................................................................................
; 0000 0065 read_from_device(AC5_add);
	LDI  R26,LOW(178)
	RCALL SUBOPT_0x3
; 0000 0066 ac5=(unsigned short int)(data[0]<<8)+data[1];
	STS  _ac5,R30
	STS  _ac5+1,R31
; 0000 0067 lcd_clear();lcd_gotoxy(0,0);lcd_putsf("  CALIBRATION");
	RCALL SUBOPT_0x4
; 0000 0068 sprintf(lcd_buf,"AC5= %d",ac5);lcd_gotoxy(0,1); lcd_puts(lcd_buf); delay_ms(100);
	__POINTW1FN _0x0,46
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0x7
; 0000 0069 //...................................................................................
; 0000 006A read_from_device(AC6_add);
	LDI  R26,LOW(180)
	RCALL SUBOPT_0x3
; 0000 006B ac6=(unsigned short int)(data[0]<<8)+data[1];
	STS  _ac6,R30
	STS  _ac6+1,R31
; 0000 006C lcd_clear();lcd_gotoxy(0,0);lcd_putsf("  CALIBRATION");
	RCALL SUBOPT_0x4
; 0000 006D sprintf(lcd_buf,"AC6= %d",ac6);lcd_gotoxy(0,1); lcd_puts(lcd_buf); delay_ms(100);
	__POINTW1FN _0x0,54
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x9
	RCALL SUBOPT_0x7
; 0000 006E //...................................................................................
; 0000 006F read_from_device(B1_add);
	LDI  R26,LOW(182)
	RCALL SUBOPT_0x3
; 0000 0070 b1=(short int)(data[0]<<8)+data[1];
	MOVW R10,R30
; 0000 0071 lcd_clear();lcd_gotoxy(0,0);lcd_putsf("  CALIBRATION");
	RCALL SUBOPT_0x4
; 0000 0072 sprintf(lcd_buf,"B1= %d",b1);lcd_gotoxy(0,1); lcd_puts(lcd_buf); delay_ms(100);
	__POINTW1FN _0x0,62
	RCALL SUBOPT_0x5
	MOVW R30,R10
	RCALL SUBOPT_0x6
; 0000 0073 //...................................................................................
; 0000 0074 read_from_device(B2_add);
	LDI  R26,LOW(184)
	RCALL SUBOPT_0x3
; 0000 0075 b2=(short int)(data[0]<<8)+data[1];
	MOVW R12,R30
; 0000 0076 lcd_clear();lcd_gotoxy(0,0);lcd_putsf("  CALIBRATION");
	RCALL SUBOPT_0x4
; 0000 0077 sprintf(lcd_buf,"B2= %d",b2);lcd_gotoxy(0,1); lcd_puts(lcd_buf); delay_ms(100);
	__POINTW1FN _0x0,69
	RCALL SUBOPT_0x5
	MOVW R30,R12
	RCALL SUBOPT_0x6
; 0000 0078 //...................................................................................
; 0000 0079 read_from_device(MB_add);
	LDI  R26,LOW(186)
	RCALL SUBOPT_0x3
; 0000 007A mb=(short int)(data[0]<<8)+data[1];
	STS  _mb,R30
	STS  _mb+1,R31
; 0000 007B lcd_clear();lcd_gotoxy(0,0);lcd_putsf("  CALIBRATION");
	RCALL SUBOPT_0x4
; 0000 007C sprintf(lcd_buf,"MB= %d",mb);lcd_gotoxy(0,1); lcd_puts(lcd_buf); delay_ms(100);
	__POINTW1FN _0x0,76
	RCALL SUBOPT_0x5
	LDS  R30,_mb
	LDS  R31,_mb+1
	RCALL SUBOPT_0x6
; 0000 007D //...................................................................................
; 0000 007E read_from_device(MC_add);
	LDI  R26,LOW(188)
	RCALL _read_from_device
; 0000 007F mc=(long int)(data[0]<<8)+data[1];
	LDS  R31,_data
	LDI  R30,LOW(0)
	RCALL SUBOPT_0xA
	RCALL SUBOPT_0xB
	__GETB1MN _data,1
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0xA
	RCALL __ADDD12
	STS  _mc,R30
	STS  _mc+1,R31
	STS  _mc+2,R22
	STS  _mc+3,R23
; 0000 0080 lcd_clear();lcd_gotoxy(0,0);lcd_putsf("  CALIBRATION");
	RCALL SUBOPT_0x4
; 0000 0081 sprintf(lcd_buf,"MC= %d",mc);lcd_gotoxy(0,1); lcd_puts(lcd_buf); delay_ms(100);
	__POINTW1FN _0x0,83
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0xD
	RCALL __PUTPARD1
	LDI  R24,4
	RCALL _sprintf
	ADIW R28,8
	RCALL SUBOPT_0xE
	LDI  R26,LOW(1)
	RCALL _lcd_gotoxy
	LDI  R26,LOW(_lcd_buf)
	LDI  R27,HIGH(_lcd_buf)
	RCALL _lcd_puts
	LDI  R26,LOW(100)
	RCALL SUBOPT_0xF
; 0000 0082 //...................................................................................
; 0000 0083 read_from_device(MD_add);
	LDI  R26,LOW(190)
	RCALL SUBOPT_0x3
; 0000 0084 md=(short int)(data[0]<<8)+data[1];
	STS  _md,R30
	STS  _md+1,R31
; 0000 0085 lcd_clear();lcd_gotoxy(0,0);lcd_putsf("  CALIBRATION");
	RCALL SUBOPT_0x4
; 0000 0086 sprintf(lcd_buf,"MD= %d",md);lcd_gotoxy(0,1); lcd_puts(lcd_buf); delay_ms(100);
	__POINTW1FN _0x0,90
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x10
	RCALL SUBOPT_0x6
; 0000 0087 //...................................................................................
; 0000 0088 }
	RET
;
;void show_temp(){
; 0000 008A void show_temp(){
_show_temp:
; 0000 008B         //*****---------calculating Temperature ---------*******
; 0000 008C         write_to_device(PT_writeAddress_register, T_control_register);
	LDI  R30,LOW(244)
	ST   -Y,R30
	LDI  R26,LOW(46)
	RCALL _write_to_device
; 0000 008D         delay_ms(5);
	LDI  R26,LOW(5)
	RCALL SUBOPT_0xF
; 0000 008E         read_from_device(0xf6)  ;
	LDI  R26,LOW(246)
	RCALL SUBOPT_0x3
; 0000 008F         UT=(long)((data[0]<<8)+data[1]);
	RCALL SUBOPT_0xA
	STS  _UT,R30
	STS  _UT+1,R31
	STS  _UT+2,R22
	STS  _UT+3,R23
; 0000 0090         x1=(UT-ac6)*ac5/(0x02<<14);
	RCALL SUBOPT_0x9
	LDS  R26,_UT
	LDS  R27,_UT+1
	LDS  R24,_UT+2
	LDS  R25,_UT+3
	CLR  R22
	CLR  R23
	RCALL __SUBD21
	RCALL SUBOPT_0x8
	CLR  R22
	CLR  R23
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0x12
	RCALL SUBOPT_0x13
; 0000 0091         x2= mc*(0x02<<10)/(x1+md) ;     // (0x02<<10) = 2 power 11
	RCALL SUBOPT_0xD
	__GETD2N 0x800
	RCALL __MULD12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x10
	RCALL SUBOPT_0x14
	RCALL SUBOPT_0xA
	RCALL __ADDD12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	RCALL SUBOPT_0x15
; 0000 0092         b5=x1+x2;
	STS  _b5,R30
	STS  _b5+1,R31
	STS  _b5+2,R22
	STS  _b5+3,R23
; 0000 0093         T=(b5+8)/(0x02<<3);
	RCALL SUBOPT_0x16
	__ADDD1N 8
	RCALL SUBOPT_0x17
	STS  _T,R30
	STS  _T+1,R31
	STS  _T+2,R22
	STS  _T+3,R23
; 0000 0094         n1=T/10;    n2=T%10;
	RCALL SUBOPT_0x18
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x18
	RCALL SUBOPT_0x1A
; 0000 0095         temp_t1=n1;
	RCALL SUBOPT_0x1B
	STS  _temp_t1,R30
	STS  _temp_t1+1,R31
; 0000 0096         temp_t2=n2;
	RCALL SUBOPT_0x1C
	STS  _temp_t2,R30
	STS  _temp_t2+1,R31
; 0000 0097         lcd_clear();
	RCALL _lcd_clear
; 0000 0098         lcd_gotoxy(0,0);
	RCALL SUBOPT_0xE
	LDI  R26,LOW(0)
	RCALL _lcd_gotoxy
; 0000 0099         sprintf(lcd_buf,"T= %d.%d \xdfC",n1,n2); // lcd
	LDI  R30,LOW(_lcd_buf)
	LDI  R31,HIGH(_lcd_buf)
	RCALL SUBOPT_0x5
	__POINTW1FN _0x0,97
	RCALL SUBOPT_0x1D
; 0000 009A 
; 0000 009B         lcd_puts(lcd_buf);
	RJMP _0x20C0009
; 0000 009C         }
;void show_pre(){
; 0000 009D void show_pre(){
_show_pre:
; 0000 009E         //********---------calculating Pressure ---------**********
; 0000 009F         write_to_device(PT_writeAddress_register , P_control_register);
	LDI  R30,LOW(244)
	ST   -Y,R30
	LDI  R26,LOW(52)
	RCALL _write_to_device
; 0000 00A0         delay_ms(5+power(3,oss));
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	RCALL SUBOPT_0x5
	LDI  R26,LOW(0)
	LDI  R27,0
	RCALL _power
	ADIW R30,5
	MOVW R26,R30
	RCALL _delay_ms
; 0000 00A1         read_from_device(0xf6);
	LDI  R26,LOW(246)
	RCALL SUBOPT_0x3
; 0000 00A2         UP=(long) ((data[0]<<8) +data[1]);
	RCALL SUBOPT_0xA
	STS  _UP,R30
	STS  _UP+1,R31
	STS  _UP+2,R22
	STS  _UP+3,R23
; 0000 00A3         b6=b5-4000-1;
	RCALL SUBOPT_0x16
	__SUBD1N 4000
	__SUBD1N 1
	STS  _b6,R30
	STS  _b6+1,R31
	STS  _b6+2,R22
	STS  _b6+3,R23
; 0000 00A4         x1=(b2*(b6*b6/(0x02<<11)))/(0x02<<10);
	RCALL SUBOPT_0x1E
	RCALL SUBOPT_0x1F
	RCALL SUBOPT_0x20
	MOVW R26,R12
	RCALL SUBOPT_0x21
	RCALL SUBOPT_0x22
	RCALL SUBOPT_0x13
; 0000 00A5         x2=ac2*b6/(0x02<<10);
	RCALL SUBOPT_0x1E
	MOVW R26,R6
	RCALL SUBOPT_0x21
	RCALL SUBOPT_0x22
	RCALL SUBOPT_0x15
; 0000 00A6         x3=x1+x2;
	RCALL SUBOPT_0x23
; 0000 00A7         b3=(((ac1*4+x3) << oss) +2)/4;
	MOVW R30,R4
	RCALL __LSLW2
	MOVW R26,R30
	RCALL SUBOPT_0x24
	RCALL __CWD2
	RCALL __ADDD21
	MOVW R30,R26
	MOVW R22,R24
	RCALL SUBOPT_0x25
	STS  _b3,R30
	STS  _b3+1,R31
	STS  _b3+2,R22
	STS  _b3+3,R23
; 0000 00A8         x1=ac3*b6/(0x02<<12);
	RCALL SUBOPT_0x1E
	MOVW R26,R8
	RCALL SUBOPT_0x21
	__GETD1N 0x2000
	RCALL SUBOPT_0x13
; 0000 00A9         x2=(b1*(b6*b6/(0x02<<11)))/(0x02<<15);
	RCALL SUBOPT_0x1E
	RCALL SUBOPT_0x1F
	RCALL SUBOPT_0x20
	MOVW R26,R10
	RCALL SUBOPT_0x21
	RCALL SUBOPT_0x26
	RCALL SUBOPT_0x15
; 0000 00AA         x3=((x1+x2)+2)/(0x02<<1);
	RCALL SUBOPT_0x25
	RCALL SUBOPT_0x23
; 0000 00AB         b4=ac4*(unsigned long)(x3+32768)/(0x02<<14);
	RCALL SUBOPT_0x24
	__ADDD1N 32768
	LDS  R26,_ac4
	LDS  R27,_ac4+1
	CLR  R24
	CLR  R25
	RCALL __MULD12U
	RCALL SUBOPT_0xB
	RCALL SUBOPT_0x12
	RCALL __DIVD21U
	STS  _b4,R30
	STS  _b4+1,R31
	STS  _b4+2,R22
	STS  _b4+3,R23
; 0000 00AC         b7=((unsigned long)UP-b3)*(50000>>oss);
	LDS  R26,_b3
	LDS  R27,_b3+1
	LDS  R24,_b3+2
	LDS  R25,_b3+3
	LDS  R30,_UP
	LDS  R31,_UP+1
	LDS  R22,_UP+2
	LDS  R23,_UP+3
	RCALL __SUBD12
	__GETD2N 0xC350
	RCALL __MULD12U
	STS  _b7,R30
	STS  _b7+1,R31
	STS  _b7+2,R22
	STS  _b7+3,R23
; 0000 00AD         if(b7 < 0x80000000){P=(b7*2)/b4;}
	RCALL SUBOPT_0x27
	__CPD2N 0x80000000
	BRSH _0x6
	LDS  R30,_b7
	LDS  R31,_b7+1
	LDS  R22,_b7+2
	LDS  R23,_b7+3
	RCALL __LSLD1
	MOVW R26,R30
	MOVW R24,R22
	RCALL SUBOPT_0x28
	RCALL __DIVD21U
	RJMP _0xC
; 0000 00AE         else {P=(b7/b4)*2;}
_0x6:
	RCALL SUBOPT_0x28
	RCALL SUBOPT_0x27
	RCALL __DIVD21U
	RCALL __LSLD1
_0xC:
	STS  _P,R30
	STS  _P+1,R31
	STS  _P+2,R22
	STS  _P+3,R23
; 0000 00AF         x1=(P/(0x02<<7))*(P/(0x02<<7));
	RCALL SUBOPT_0x29
	__GETD1N 0x100
	RCALL __DIVD21
	RCALL SUBOPT_0xB
	RCALL __MULD12
	STS  _x1,R30
	STS  _x1+1,R31
	STS  _x1+2,R22
	STS  _x1+3,R23
; 0000 00B0         x1=(x1*3038)/(0x02<<15);
	__GETD2N 0xBDE
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0x26
	RCALL SUBOPT_0x13
; 0000 00B1         x2=(-7357*P)/(0x02<<15);
	LDS  R30,_P
	LDS  R31,_P+1
	LDS  R22,_P+2
	LDS  R23,_P+3
	__GETD2N 0xFFFFE343
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0x26
	RCALL SUBOPT_0x15
; 0000 00B2         P=P+(x1+x2+3791)/(0x02<<3);
	__ADDD1N 3791
	RCALL SUBOPT_0x17
	RCALL SUBOPT_0x29
	RCALL __ADDD12
	STS  _P,R30
	STS  _P+1,R31
	STS  _P+2,R22
	STS  _P+3,R23
; 0000 00B3         n1=P/10000;     n2=P%10000;
	RCALL SUBOPT_0x2A
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x2A
	RCALL SUBOPT_0x1A
; 0000 00B4      sprintf(lcd_buf,"P= %d%d Pa",n1,n2); /// P is big num for that we / it to n1 n2..
	LDI  R30,LOW(_lcd_buf)
	LDI  R31,HIGH(_lcd_buf)
	RCALL SUBOPT_0x5
	__POINTW1FN _0x0,109
	RCALL SUBOPT_0x1D
; 0000 00B5        lcd_gotoxy(0,1);
	RCALL SUBOPT_0xE
	LDI  R26,LOW(1)
	RCALL _lcd_gotoxy
; 0000 00B6        lcd_puts(lcd_buf);
_0x20C0009:
	LDI  R26,LOW(_lcd_buf)
	LDI  R27,HIGH(_lcd_buf)
	RCALL _lcd_puts
; 0000 00B7       //
; 0000 00B8        }
	RET
;///end fffffff
;
;void main(void)
; 0000 00BC {
_main:
; 0000 00BD 
; 0000 00BE 
; 0000 00BF 
; 0000 00C0 
; 0000 00C1 lcd_init(16);
	LDI  R26,LOW(16)
	RCALL _lcd_init
; 0000 00C2 
; 0000 00C3 
; 0000 00C4 
; 0000 00C5   lcd_clear();
	RCALL _lcd_clear
; 0000 00C6   lcd_putsf("BMP180 ");
	__POINTW2FN _0x0,120
	RCALL _lcd_putsf
; 0000 00C7   delay_us(100);
	RCALL SUBOPT_0x2B
; 0000 00C8   lcd_gotoxy(0,1);
	RCALL SUBOPT_0xE
	LDI  R26,LOW(1)
	RCALL _lcd_gotoxy
; 0000 00C9   lcd_putsf("Pressure/Temp...");
	__POINTW2FN _0x0,128
	RCALL _lcd_putsf
; 0000 00CA   delay_ms(400);
	LDI  R26,LOW(400)
	LDI  R27,HIGH(400)
	RCALL _delay_ms
; 0000 00CB 
; 0000 00CC 
; 0000 00CD i2c_init();
	RCALL _i2c_init
; 0000 00CE calibre();
	RCALL _calibre
; 0000 00CF 
; 0000 00D0 
; 0000 00D1 while(1)
_0x8:
; 0000 00D2     {
; 0000 00D3 
; 0000 00D4      show_temp();
	RCALL _show_temp
; 0000 00D5      show_pre();
	RCALL _show_pre
; 0000 00D6      delay_ms(1000);
	LDI  R26,LOW(1000)
	LDI  R27,HIGH(1000)
	RCALL _delay_ms
; 0000 00D7     }
	RJMP _0x8
; 0000 00D8 }
_0xB:
	RJMP _0xB
;
;
;

	.CSEG
_ftrunc:
	RCALL __PUTPARD2
   ldd  r23,y+3
   ldd  r22,y+2
   ldd  r31,y+1
   ld   r30,y
   bst  r23,7
   lsl  r23
   sbrc r22,7
   sbr  r23,1
   mov  r25,r23
   subi r25,0x7e
   breq __ftrunc0
   brcs __ftrunc0
   cpi  r25,24
   brsh __ftrunc1
   clr  r26
   clr  r27
   clr  r24
__ftrunc2:
   sec
   ror  r24
   ror  r27
   ror  r26
   dec  r25
   brne __ftrunc2
   and  r30,r26
   and  r31,r27
   and  r22,r24
   rjmp __ftrunc1
__ftrunc0:
   clt
   clr  r23
   clr  r30
   clr  r31
   clr  r22
__ftrunc1:
   cbr  r22,0x80
   lsr  r23
   brcc __ftrunc3
   sbr  r22,0x80
__ftrunc3:
   bld  r23,7
   ld   r26,y+
   ld   r27,y+
   ld   r24,y+
   ld   r25,y+
   cp   r30,r26
   cpc  r31,r27
   cpc  r22,r24
   cpc  r23,r25
   bst  r25,7
   ret
_floor:
	RCALL __PUTPARD2
	RCALL __GETD2S0
	RCALL _ftrunc
	RCALL __PUTD1S0
    brne __floor1
__floor0:
	RCALL SUBOPT_0x2C
	RJMP _0x20C0008
__floor1:
    brtc __floor0
	RCALL SUBOPT_0x2C
	__GETD2N 0x3F800000
	RCALL __SUBF12
_0x20C0008:
	ADIW R28,4
	RET
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.DSEG

	.CSEG
__lcd_write_nibble_G101:
	ST   -Y,R26
	LD   R30,Y
	ANDI R30,LOW(0x10)
	BREQ _0x2020004
	SBI  0x12,4
	RJMP _0x2020005
_0x2020004:
	CBI  0x12,4
_0x2020005:
	LD   R30,Y
	ANDI R30,LOW(0x20)
	BREQ _0x2020006
	SBI  0x12,3
	RJMP _0x2020007
_0x2020006:
	CBI  0x12,3
_0x2020007:
	LD   R30,Y
	ANDI R30,LOW(0x40)
	BREQ _0x2020008
	SBI  0x12,2
	RJMP _0x2020009
_0x2020008:
	CBI  0x12,2
_0x2020009:
	LD   R30,Y
	ANDI R30,LOW(0x80)
	BREQ _0x202000A
	SBI  0x12,1
	RJMP _0x202000B
_0x202000A:
	CBI  0x12,1
_0x202000B:
	__DELAY_USB 5
	SBI  0x12,5
	__DELAY_USB 13
	CBI  0x12,5
	__DELAY_USB 13
	RJMP _0x20C0005
__lcd_write_data:
	ST   -Y,R26
	LD   R26,Y
	RCALL __lcd_write_nibble_G101
    ld    r30,y
    swap  r30
    st    y,r30
	LD   R26,Y
	RCALL __lcd_write_nibble_G101
	__DELAY_USB 133
	RJMP _0x20C0005
_lcd_gotoxy:
	ST   -Y,R26
	LD   R30,Y
	RCALL SUBOPT_0xC
	SUBI R30,LOW(-__base_y_G101)
	SBCI R31,HIGH(-__base_y_G101)
	LD   R30,Z
	LDD  R26,Y+1
	ADD  R26,R30
	RCALL __lcd_write_data
	LDD  R30,Y+1
	STS  __lcd_x,R30
	LD   R30,Y
	STS  __lcd_y,R30
_0x20C0007:
	ADIW R28,2
	RET
_lcd_clear:
	LDI  R26,LOW(2)
	RCALL __lcd_write_data
	LDI  R26,LOW(3)
	RCALL SUBOPT_0xF
	LDI  R26,LOW(12)
	RCALL __lcd_write_data
	LDI  R26,LOW(1)
	RCALL __lcd_write_data
	LDI  R26,LOW(3)
	RCALL SUBOPT_0xF
	LDI  R30,LOW(0)
	STS  __lcd_y,R30
	STS  __lcd_x,R30
	RET
_lcd_putchar:
	ST   -Y,R26
	LD   R26,Y
	CPI  R26,LOW(0xA)
	BREQ _0x2020011
	LDS  R30,__lcd_maxx
	LDS  R26,__lcd_x
	CP   R26,R30
	BRLO _0x2020010
_0x2020011:
	RCALL SUBOPT_0xE
	LDS  R26,__lcd_y
	SUBI R26,-LOW(1)
	STS  __lcd_y,R26
	RCALL _lcd_gotoxy
	LD   R26,Y
	CPI  R26,LOW(0xA)
	BRNE _0x2020013
	RJMP _0x20C0005
_0x2020013:
_0x2020010:
	LDS  R30,__lcd_x
	SUBI R30,-LOW(1)
	STS  __lcd_x,R30
	SBI  0x12,7
	LD   R26,Y
	RCALL __lcd_write_data
	CBI  0x12,7
	RJMP _0x20C0005
_lcd_puts:
	RCALL SUBOPT_0x1
	ST   -Y,R17
_0x2020014:
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	LD   R30,X+
	STD  Y+1,R26
	STD  Y+1+1,R27
	MOV  R17,R30
	CPI  R30,0
	BREQ _0x2020016
	MOV  R26,R17
	RCALL _lcd_putchar
	RJMP _0x2020014
_0x2020016:
	RJMP _0x20C0006
_lcd_putsf:
	RCALL SUBOPT_0x1
	ST   -Y,R17
_0x2020017:
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	ADIW R30,1
	STD  Y+1,R30
	STD  Y+1+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R17,R30
	CPI  R30,0
	BREQ _0x2020019
	MOV  R26,R17
	RCALL _lcd_putchar
	RJMP _0x2020017
_0x2020019:
_0x20C0006:
	LDD  R17,Y+0
	ADIW R28,3
	RET
_lcd_init:
	ST   -Y,R26
	SBI  0x11,4
	SBI  0x11,3
	SBI  0x11,2
	SBI  0x11,1
	SBI  0x11,5
	SBI  0x11,7
	SBI  0x11,6
	CBI  0x12,5
	CBI  0x12,7
	CBI  0x12,6
	LD   R30,Y
	STS  __lcd_maxx,R30
	SUBI R30,-LOW(128)
	__PUTB1MN __base_y_G101,2
	LD   R30,Y
	SUBI R30,-LOW(192)
	__PUTB1MN __base_y_G101,3
	LDI  R26,LOW(20)
	RCALL SUBOPT_0xF
	RCALL SUBOPT_0x2D
	RCALL SUBOPT_0x2D
	RCALL SUBOPT_0x2D
	LDI  R26,LOW(32)
	RCALL __lcd_write_nibble_G101
	RCALL SUBOPT_0x2B
	LDI  R26,LOW(40)
	RCALL __lcd_write_data
	LDI  R26,LOW(4)
	RCALL __lcd_write_data
	LDI  R26,LOW(133)
	RCALL __lcd_write_data
	LDI  R26,LOW(6)
	RCALL __lcd_write_data
	RCALL _lcd_clear
_0x20C0005:
	ADIW R28,1
	RET
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.CSEG
_put_buff_G102:
	RCALL SUBOPT_0x1
	RCALL __SAVELOCR2
	RCALL SUBOPT_0x2E
	ADIW R26,2
	RCALL __GETW1P
	SBIW R30,0
	BREQ _0x2040010
	RCALL SUBOPT_0x2E
	RCALL SUBOPT_0x2F
	MOVW R16,R30
	SBIW R30,0
	BREQ _0x2040012
	__CPWRN 16,17,2
	BRLO _0x2040013
	MOVW R30,R16
	SBIW R30,1
	MOVW R16,R30
	__PUTW1SNS 2,4
_0x2040012:
	RCALL SUBOPT_0x2E
	ADIW R26,2
	RCALL SUBOPT_0x30
	SBIW R30,1
	LDD  R26,Y+4
	STD  Z+0,R26
	RCALL SUBOPT_0x2E
	RCALL __GETW1P
	TST  R31
	BRMI _0x2040014
	RCALL SUBOPT_0x2E
	RCALL SUBOPT_0x30
_0x2040014:
_0x2040013:
	RJMP _0x2040015
_0x2040010:
	RCALL SUBOPT_0x2E
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	ST   X+,R30
	ST   X,R31
_0x2040015:
	RCALL __LOADLOCR2
	ADIW R28,5
	RET
__ftoe_G102:
	RCALL SUBOPT_0x31
	LDI  R30,LOW(128)
	STD  Y+2,R30
	LDI  R30,LOW(63)
	STD  Y+3,R30
	RCALL __SAVELOCR4
	LDD  R30,Y+14
	LDD  R31,Y+14+1
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BRNE _0x2040019
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	RCALL SUBOPT_0x5
	__POINTW2FN _0x2040000,0
	RCALL _strcpyf
	RJMP _0x20C0004
_0x2040019:
	CPI  R30,LOW(0x7FFF)
	LDI  R26,HIGH(0x7FFF)
	CPC  R31,R26
	BRNE _0x2040018
	RCALL SUBOPT_0x32
	RCALL SUBOPT_0x5
	__POINTW2FN _0x2040000,1
	RCALL _strcpyf
	RJMP _0x20C0004
_0x2040018:
	LDD  R26,Y+11
	CPI  R26,LOW(0x7)
	BRLO _0x204001B
	LDI  R30,LOW(6)
	STD  Y+11,R30
_0x204001B:
	LDD  R17,Y+11
_0x204001C:
	RCALL SUBOPT_0x33
	BREQ _0x204001E
	RCALL SUBOPT_0x34
	RJMP _0x204001C
_0x204001E:
	RCALL SUBOPT_0x35
	RCALL __CPD10
	BRNE _0x204001F
	LDI  R19,LOW(0)
	RCALL SUBOPT_0x34
	RJMP _0x2040020
_0x204001F:
	LDD  R19,Y+11
	RCALL SUBOPT_0x36
	BREQ PC+2
	BRCC PC+2
	RJMP _0x2040021
	RCALL SUBOPT_0x34
_0x2040022:
	RCALL SUBOPT_0x36
	BRLO _0x2040024
	RCALL SUBOPT_0x37
	RCALL SUBOPT_0x38
	RJMP _0x2040022
_0x2040024:
	RJMP _0x2040025
_0x2040021:
_0x2040026:
	RCALL SUBOPT_0x36
	BRSH _0x2040028
	RCALL SUBOPT_0x37
	RCALL SUBOPT_0x39
	RCALL SUBOPT_0x3A
	SUBI R19,LOW(1)
	RJMP _0x2040026
_0x2040028:
	RCALL SUBOPT_0x34
_0x2040025:
	RCALL SUBOPT_0x35
	RCALL SUBOPT_0x3B
	RCALL SUBOPT_0x3A
	RCALL SUBOPT_0x36
	BRLO _0x2040029
	RCALL SUBOPT_0x37
	RCALL SUBOPT_0x38
_0x2040029:
_0x2040020:
	LDI  R17,LOW(0)
_0x204002A:
	LDD  R30,Y+11
	CP   R30,R17
	BRLO _0x204002C
	RCALL SUBOPT_0x3C
	RCALL SUBOPT_0x3D
	RCALL SUBOPT_0x3B
	RCALL SUBOPT_0xB
	RCALL _floor
	__PUTD1S 4
	RCALL SUBOPT_0x37
	RCALL __DIVF21
	RCALL __CFD1U
	MOV  R16,R30
	RCALL SUBOPT_0x3E
	RCALL SUBOPT_0x3F
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL __CDF1
	RCALL SUBOPT_0x3C
	RCALL __MULF12
	RCALL SUBOPT_0x37
	RCALL __SWAPD12
	RCALL __SUBF12
	RCALL SUBOPT_0x3A
	MOV  R30,R17
	SUBI R17,-1
	CPI  R30,0
	BRNE _0x204002A
	RCALL SUBOPT_0x3E
	LDI  R30,LOW(46)
	ST   X,R30
	RJMP _0x204002A
_0x204002C:
	RCALL SUBOPT_0x40
	SBIW R30,1
	LDD  R26,Y+10
	STD  Z+0,R26
	CPI  R19,0
	BRGE _0x204002E
	NEG  R19
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDI  R30,LOW(45)
	RJMP _0x204010E
_0x204002E:
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDI  R30,LOW(43)
_0x204010E:
	ST   X,R30
	RCALL SUBOPT_0x40
	RCALL SUBOPT_0x40
	RCALL SUBOPT_0x41
	RCALL __DIVB21
	SUBI R30,-LOW(48)
	MOVW R26,R22
	ST   X,R30
	RCALL SUBOPT_0x40
	RCALL SUBOPT_0x41
	RCALL __MODB21
	SUBI R30,-LOW(48)
	MOVW R26,R22
	ST   X,R30
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDI  R30,LOW(0)
	ST   X,R30
_0x20C0004:
	RCALL __LOADLOCR4
	ADIW R28,16
	RET
__print_G102:
	RCALL SUBOPT_0x1
	SBIW R28,63
	SBIW R28,17
	RCALL __SAVELOCR6
	LDI  R17,0
	__GETW1SX 88
	STD  Y+8,R30
	STD  Y+8+1,R31
	__GETW1SX 86
	STD  Y+6,R30
	STD  Y+6+1,R31
	RCALL SUBOPT_0x42
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   X+,R30
	ST   X,R31
_0x2040030:
	MOVW R26,R28
	SUBI R26,LOW(-(92))
	SBCI R27,HIGH(-(92))
	RCALL SUBOPT_0x30
	SBIW R30,1
	LPM  R30,Z
	MOV  R18,R30
	CPI  R30,0
	BRNE PC+2
	RJMP _0x2040032
	MOV  R30,R17
	CPI  R30,0
	BRNE _0x2040036
	CPI  R18,37
	BRNE _0x2040037
	LDI  R17,LOW(1)
	RJMP _0x2040038
_0x2040037:
	RCALL SUBOPT_0x43
_0x2040038:
	RJMP _0x2040035
_0x2040036:
	CPI  R30,LOW(0x1)
	BRNE _0x2040039
	CPI  R18,37
	BRNE _0x204003A
	RCALL SUBOPT_0x43
	RJMP _0x204010F
_0x204003A:
	LDI  R17,LOW(2)
	LDI  R30,LOW(0)
	STD  Y+21,R30
	LDI  R16,LOW(0)
	CPI  R18,45
	BRNE _0x204003B
	LDI  R16,LOW(1)
	RJMP _0x2040035
_0x204003B:
	CPI  R18,43
	BRNE _0x204003C
	LDI  R30,LOW(43)
	STD  Y+21,R30
	RJMP _0x2040035
_0x204003C:
	CPI  R18,32
	BRNE _0x204003D
	LDI  R30,LOW(32)
	STD  Y+21,R30
	RJMP _0x2040035
_0x204003D:
	RJMP _0x204003E
_0x2040039:
	CPI  R30,LOW(0x2)
	BRNE _0x204003F
_0x204003E:
	LDI  R21,LOW(0)
	LDI  R17,LOW(3)
	CPI  R18,48
	BRNE _0x2040040
	ORI  R16,LOW(128)
	RJMP _0x2040035
_0x2040040:
	RJMP _0x2040041
_0x204003F:
	CPI  R30,LOW(0x3)
	BRNE _0x2040042
_0x2040041:
	CPI  R18,48
	BRLO _0x2040044
	CPI  R18,58
	BRLO _0x2040045
_0x2040044:
	RJMP _0x2040043
_0x2040045:
	LDI  R26,LOW(10)
	MUL  R21,R26
	MOV  R21,R0
	MOV  R30,R18
	SUBI R30,LOW(48)
	ADD  R21,R30
	RJMP _0x2040035
_0x2040043:
	LDI  R20,LOW(0)
	CPI  R18,46
	BRNE _0x2040046
	LDI  R17,LOW(4)
	RJMP _0x2040035
_0x2040046:
	RJMP _0x2040047
_0x2040042:
	CPI  R30,LOW(0x4)
	BRNE _0x2040049
	CPI  R18,48
	BRLO _0x204004B
	CPI  R18,58
	BRLO _0x204004C
_0x204004B:
	RJMP _0x204004A
_0x204004C:
	ORI  R16,LOW(32)
	LDI  R26,LOW(10)
	MUL  R20,R26
	MOV  R20,R0
	MOV  R30,R18
	SUBI R30,LOW(48)
	ADD  R20,R30
	RJMP _0x2040035
_0x204004A:
_0x2040047:
	CPI  R18,108
	BRNE _0x204004D
	ORI  R16,LOW(2)
	LDI  R17,LOW(5)
	RJMP _0x2040035
_0x204004D:
	RJMP _0x204004E
_0x2040049:
	CPI  R30,LOW(0x5)
	BREQ PC+2
	RJMP _0x2040035
_0x204004E:
	MOV  R30,R18
	CPI  R30,LOW(0x63)
	BRNE _0x2040053
	RCALL SUBOPT_0x44
	RCALL SUBOPT_0x45
	RCALL SUBOPT_0x44
	LDD  R26,Z+4
	ST   -Y,R26
	RCALL SUBOPT_0x46
	RJMP _0x2040054
_0x2040053:
	CPI  R30,LOW(0x45)
	BREQ _0x2040057
	CPI  R30,LOW(0x65)
	BRNE _0x2040058
_0x2040057:
	RJMP _0x2040059
_0x2040058:
	CPI  R30,LOW(0x66)
	BRNE _0x204005A
_0x2040059:
	RCALL SUBOPT_0x47
	RCALL SUBOPT_0x48
	RCALL __GETD1P
	RCALL SUBOPT_0x49
	RCALL SUBOPT_0x4A
	LDD  R26,Y+13
	TST  R26
	BRMI _0x204005B
	LDD  R26,Y+21
	CPI  R26,LOW(0x2B)
	BREQ _0x204005D
	RJMP _0x204005E
_0x204005B:
	RCALL SUBOPT_0x4B
	RCALL __ANEGF1
	RCALL SUBOPT_0x49
	LDI  R30,LOW(45)
	STD  Y+21,R30
_0x204005D:
	SBRS R16,7
	RJMP _0x204005F
	LDD  R30,Y+21
	ST   -Y,R30
	RCALL SUBOPT_0x46
	RJMP _0x2040060
_0x204005F:
	LDD  R30,Y+14
	LDD  R31,Y+14+1
	ADIW R30,1
	RCALL SUBOPT_0x4C
	SBIW R30,1
	LDD  R26,Y+21
	STD  Z+0,R26
_0x2040060:
_0x204005E:
	SBRS R16,5
	LDI  R20,LOW(6)
	CPI  R18,102
	BRNE _0x2040062
	RCALL SUBOPT_0x4B
	RCALL __PUTPARD1
	ST   -Y,R20
	LDD  R26,Y+19
	LDD  R27,Y+19+1
	RCALL _ftoa
	RJMP _0x2040063
_0x2040062:
	RCALL SUBOPT_0x4B
	RCALL __PUTPARD1
	ST   -Y,R20
	ST   -Y,R18
	LDD  R26,Y+20
	LDD  R27,Y+20+1
	RCALL __ftoe_G102
_0x2040063:
	RCALL SUBOPT_0x47
	RCALL SUBOPT_0x4D
	RJMP _0x2040064
_0x204005A:
	CPI  R30,LOW(0x73)
	BRNE _0x2040066
	RCALL SUBOPT_0x4A
	RCALL SUBOPT_0x4E
	RCALL SUBOPT_0x4C
	RCALL SUBOPT_0x4D
	RJMP _0x2040067
_0x2040066:
	CPI  R30,LOW(0x70)
	BRNE _0x2040069
	RCALL SUBOPT_0x4A
	RCALL SUBOPT_0x4E
	RCALL SUBOPT_0x4C
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	RCALL _strlenf
	MOV  R17,R30
	ORI  R16,LOW(8)
_0x2040067:
	ANDI R16,LOW(127)
	CPI  R20,0
	BREQ _0x204006B
	CP   R20,R17
	BRLO _0x204006C
_0x204006B:
	RJMP _0x204006A
_0x204006C:
	MOV  R17,R20
_0x204006A:
_0x2040064:
	LDI  R20,LOW(0)
	LDI  R30,LOW(0)
	STD  Y+20,R30
	LDI  R19,LOW(0)
	RJMP _0x204006D
_0x2040069:
	CPI  R30,LOW(0x64)
	BREQ _0x2040070
	CPI  R30,LOW(0x69)
	BRNE _0x2040071
_0x2040070:
	ORI  R16,LOW(4)
	RJMP _0x2040072
_0x2040071:
	CPI  R30,LOW(0x75)
	BRNE _0x2040073
_0x2040072:
	LDI  R30,LOW(10)
	STD  Y+20,R30
	SBRS R16,1
	RJMP _0x2040074
	__GETD1N 0x3B9ACA00
	RCALL SUBOPT_0x4F
	LDI  R17,LOW(10)
	RJMP _0x2040075
_0x2040074:
	__GETD1N 0x2710
	RCALL SUBOPT_0x4F
	LDI  R17,LOW(5)
	RJMP _0x2040075
_0x2040073:
	CPI  R30,LOW(0x58)
	BRNE _0x2040077
	ORI  R16,LOW(8)
	RJMP _0x2040078
_0x2040077:
	CPI  R30,LOW(0x78)
	BREQ PC+2
	RJMP _0x20400B6
_0x2040078:
	LDI  R30,LOW(16)
	STD  Y+20,R30
	SBRS R16,1
	RJMP _0x204007A
	__GETD1N 0x10000000
	RCALL SUBOPT_0x4F
	LDI  R17,LOW(8)
	RJMP _0x2040075
_0x204007A:
	__GETD1N 0x1000
	RCALL SUBOPT_0x4F
	LDI  R17,LOW(4)
_0x2040075:
	CPI  R20,0
	BREQ _0x204007B
	ANDI R16,LOW(127)
	RJMP _0x204007C
_0x204007B:
	LDI  R20,LOW(1)
_0x204007C:
	SBRS R16,1
	RJMP _0x204007D
	RCALL SUBOPT_0x4A
	RCALL SUBOPT_0x48
	ADIW R26,4
	RCALL __GETD1P
	RJMP _0x2040110
_0x204007D:
	SBRS R16,2
	RJMP _0x204007F
	RCALL SUBOPT_0x4A
	RCALL SUBOPT_0x4E
	RCALL SUBOPT_0xA
	RJMP _0x2040110
_0x204007F:
	RCALL SUBOPT_0x4A
	RCALL SUBOPT_0x4E
	CLR  R22
	CLR  R23
_0x2040110:
	__PUTD1S 10
	SBRS R16,2
	RJMP _0x2040081
	LDD  R26,Y+13
	TST  R26
	BRPL _0x2040082
	RCALL SUBOPT_0x4B
	RCALL __ANEGD1
	RCALL SUBOPT_0x49
	LDI  R30,LOW(45)
	STD  Y+21,R30
_0x2040082:
	LDD  R30,Y+21
	CPI  R30,0
	BREQ _0x2040083
	SUBI R17,-LOW(1)
	SUBI R20,-LOW(1)
	RJMP _0x2040084
_0x2040083:
	ANDI R16,LOW(251)
_0x2040084:
_0x2040081:
	MOV  R19,R20
_0x204006D:
	SBRC R16,0
	RJMP _0x2040085
_0x2040086:
	CP   R17,R21
	BRSH _0x2040089
	CP   R19,R21
	BRLO _0x204008A
_0x2040089:
	RJMP _0x2040088
_0x204008A:
	SBRS R16,7
	RJMP _0x204008B
	SBRS R16,2
	RJMP _0x204008C
	ANDI R16,LOW(251)
	LDD  R18,Y+21
	SUBI R17,LOW(1)
	RJMP _0x204008D
_0x204008C:
	LDI  R18,LOW(48)
_0x204008D:
	RJMP _0x204008E
_0x204008B:
	LDI  R18,LOW(32)
_0x204008E:
	RCALL SUBOPT_0x43
	SUBI R21,LOW(1)
	RJMP _0x2040086
_0x2040088:
_0x2040085:
_0x204008F:
	CP   R17,R20
	BRSH _0x2040091
	ORI  R16,LOW(16)
	SBRS R16,2
	RJMP _0x2040092
	RCALL SUBOPT_0x50
	BREQ _0x2040093
	SUBI R21,LOW(1)
_0x2040093:
	SUBI R17,LOW(1)
	SUBI R20,LOW(1)
_0x2040092:
	LDI  R30,LOW(48)
	ST   -Y,R30
	RCALL SUBOPT_0x46
	CPI  R21,0
	BREQ _0x2040094
	SUBI R21,LOW(1)
_0x2040094:
	SUBI R20,LOW(1)
	RJMP _0x204008F
_0x2040091:
	MOV  R19,R17
	LDD  R30,Y+20
	CPI  R30,0
	BRNE _0x2040095
_0x2040096:
	CPI  R19,0
	BREQ _0x2040098
	SBRS R16,3
	RJMP _0x2040099
	LDD  R30,Y+14
	LDD  R31,Y+14+1
	LPM  R18,Z+
	RCALL SUBOPT_0x4C
	RJMP _0x204009A
_0x2040099:
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	LD   R18,X+
	STD  Y+14,R26
	STD  Y+14+1,R27
_0x204009A:
	RCALL SUBOPT_0x43
	CPI  R21,0
	BREQ _0x204009B
	SUBI R21,LOW(1)
_0x204009B:
	SUBI R19,LOW(1)
	RJMP _0x2040096
_0x2040098:
	RJMP _0x204009C
_0x2040095:
_0x204009E:
	RCALL SUBOPT_0x51
	RCALL __DIVD21U
	MOV  R18,R30
	CPI  R18,10
	BRLO _0x20400A0
	SBRS R16,3
	RJMP _0x20400A1
	SUBI R18,-LOW(55)
	RJMP _0x20400A2
_0x20400A1:
	SUBI R18,-LOW(87)
_0x20400A2:
	RJMP _0x20400A3
_0x20400A0:
	SUBI R18,-LOW(48)
_0x20400A3:
	SBRC R16,4
	RJMP _0x20400A5
	CPI  R18,49
	BRSH _0x20400A7
	RCALL SUBOPT_0x52
	__CPD2N 0x1
	BRNE _0x20400A6
_0x20400A7:
	RJMP _0x20400A9
_0x20400A6:
	CP   R20,R19
	BRSH _0x2040111
	CP   R21,R19
	BRLO _0x20400AC
	SBRS R16,0
	RJMP _0x20400AD
_0x20400AC:
	RJMP _0x20400AB
_0x20400AD:
	LDI  R18,LOW(32)
	SBRS R16,7
	RJMP _0x20400AE
_0x2040111:
	LDI  R18,LOW(48)
_0x20400A9:
	ORI  R16,LOW(16)
	SBRS R16,2
	RJMP _0x20400AF
	RCALL SUBOPT_0x50
	BREQ _0x20400B0
	SUBI R21,LOW(1)
_0x20400B0:
_0x20400AF:
_0x20400AE:
_0x20400A5:
	RCALL SUBOPT_0x43
	CPI  R21,0
	BREQ _0x20400B1
	SUBI R21,LOW(1)
_0x20400B1:
_0x20400AB:
	SUBI R19,LOW(1)
	RCALL SUBOPT_0x51
	RCALL __MODD21U
	RCALL SUBOPT_0x49
	LDD  R30,Y+20
	RCALL SUBOPT_0x52
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL __DIVD21U
	RCALL SUBOPT_0x4F
	__GETD1S 16
	RCALL __CPD10
	BREQ _0x204009F
	RJMP _0x204009E
_0x204009F:
_0x204009C:
	SBRS R16,0
	RJMP _0x20400B2
_0x20400B3:
	CPI  R21,0
	BREQ _0x20400B5
	SUBI R21,LOW(1)
	LDI  R30,LOW(32)
	ST   -Y,R30
	RCALL SUBOPT_0x46
	RJMP _0x20400B3
_0x20400B5:
_0x20400B2:
_0x20400B6:
_0x2040054:
_0x204010F:
	LDI  R17,LOW(0)
_0x2040035:
	RJMP _0x2040030
_0x2040032:
	RCALL SUBOPT_0x42
	RCALL __GETW1P
	RCALL __LOADLOCR6
	ADIW R28,63
	ADIW R28,31
	RET
_sprintf:
	PUSH R15
	MOV  R15,R24
	SBIW R28,6
	RCALL __SAVELOCR4
	RCALL SUBOPT_0x53
	SBIW R30,0
	BRNE _0x20400B7
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	RJMP _0x20C0003
_0x20400B7:
	MOVW R26,R28
	ADIW R26,6
	RCALL __ADDW2R15
	MOVW R16,R26
	RCALL SUBOPT_0x53
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R30,LOW(0)
	STD  Y+8,R30
	STD  Y+8+1,R30
	MOVW R26,R28
	ADIW R26,10
	RCALL __ADDW2R15
	RCALL __GETW1P
	RCALL SUBOPT_0x5
	ST   -Y,R17
	ST   -Y,R16
	LDI  R30,LOW(_put_buff_G102)
	LDI  R31,HIGH(_put_buff_G102)
	RCALL SUBOPT_0x5
	MOVW R26,R28
	ADIW R26,10
	RCALL __print_G102
	MOVW R18,R30
	RCALL SUBOPT_0x42
	LDI  R30,LOW(0)
	ST   X,R30
	MOVW R30,R18
_0x20C0003:
	RCALL __LOADLOCR4
	ADIW R28,10
	POP  R15
	RET

	.CSEG
_ftoa:
	RCALL SUBOPT_0x31
	LDI  R30,LOW(0)
	STD  Y+2,R30
	LDI  R30,LOW(63)
	STD  Y+3,R30
	RCALL __SAVELOCR2
	LDD  R30,Y+11
	LDD  R31,Y+11+1
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BRNE _0x206000D
	RCALL SUBOPT_0x2
	RCALL SUBOPT_0x5
	__POINTW2FN _0x2060000,0
	RCALL _strcpyf
	RJMP _0x20C0002
_0x206000D:
	CPI  R30,LOW(0x7FFF)
	LDI  R26,HIGH(0x7FFF)
	CPC  R31,R26
	BRNE _0x206000C
	RCALL SUBOPT_0x2
	RCALL SUBOPT_0x5
	__POINTW2FN _0x2060000,1
	RCALL _strcpyf
	RJMP _0x20C0002
_0x206000C:
	LDD  R26,Y+12
	TST  R26
	BRPL _0x206000F
	RCALL SUBOPT_0x54
	RCALL __ANEGF1
	RCALL SUBOPT_0x55
	RCALL SUBOPT_0x56
	LDI  R30,LOW(45)
	ST   X,R30
_0x206000F:
	LDD  R26,Y+8
	CPI  R26,LOW(0x7)
	BRLO _0x2060010
	LDI  R30,LOW(6)
	STD  Y+8,R30
_0x2060010:
	LDD  R17,Y+8
_0x2060011:
	RCALL SUBOPT_0x33
	BREQ _0x2060013
	RCALL SUBOPT_0x57
	RCALL SUBOPT_0x3D
	RCALL SUBOPT_0x58
	RJMP _0x2060011
_0x2060013:
	RCALL SUBOPT_0x59
	RCALL __ADDF12
	RCALL SUBOPT_0x55
	LDI  R17,LOW(0)
	__GETD1N 0x3F800000
	RCALL SUBOPT_0x58
_0x2060014:
	RCALL SUBOPT_0x59
	RCALL __CMPF12
	BRLO _0x2060016
	RCALL SUBOPT_0x57
	RCALL SUBOPT_0x39
	RCALL SUBOPT_0x58
	SUBI R17,-LOW(1)
	CPI  R17,39
	BRLO _0x2060017
	RCALL SUBOPT_0x2
	RCALL SUBOPT_0x5
	__POINTW2FN _0x2060000,5
	RCALL _strcpyf
	RJMP _0x20C0002
_0x2060017:
	RJMP _0x2060014
_0x2060016:
	CPI  R17,0
	BRNE _0x2060018
	RCALL SUBOPT_0x56
	LDI  R30,LOW(48)
	ST   X,R30
	RJMP _0x2060019
_0x2060018:
_0x206001A:
	RCALL SUBOPT_0x33
	BREQ _0x206001C
	RCALL SUBOPT_0x57
	RCALL SUBOPT_0x3D
	RCALL SUBOPT_0x3B
	RCALL SUBOPT_0xB
	RCALL _floor
	RCALL SUBOPT_0x58
	RCALL SUBOPT_0x59
	RCALL __DIVF21
	RCALL __CFD1U
	MOV  R16,R30
	RCALL SUBOPT_0x56
	RCALL SUBOPT_0x3F
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0x57
	RCALL __CWD1
	RCALL __CDF1
	RCALL __MULF12
	RCALL SUBOPT_0x5A
	RCALL __SWAPD12
	RCALL __SUBF12
	RCALL SUBOPT_0x55
	RJMP _0x206001A
_0x206001C:
_0x2060019:
	LDD  R30,Y+8
	CPI  R30,0
	BREQ _0x20C0001
	RCALL SUBOPT_0x56
	LDI  R30,LOW(46)
	ST   X,R30
_0x206001E:
	LDD  R30,Y+8
	SUBI R30,LOW(1)
	STD  Y+8,R30
	SUBI R30,-LOW(1)
	BREQ _0x2060020
	RCALL SUBOPT_0x5A
	RCALL SUBOPT_0x39
	RCALL SUBOPT_0x55
	RCALL SUBOPT_0x54
	RCALL __CFD1U
	MOV  R16,R30
	RCALL SUBOPT_0x56
	RCALL SUBOPT_0x3F
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0x5A
	RCALL __CWD1
	RCALL __CDF1
	RCALL __SWAPD12
	RCALL __SUBF12
	RCALL SUBOPT_0x55
	RJMP _0x206001E
_0x2060020:
_0x20C0001:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LDI  R30,LOW(0)
	ST   X,R30
_0x20C0002:
	RCALL __LOADLOCR2
	ADIW R28,13
	RET

	.DSEG

	.CSEG

	.CSEG

	.CSEG
_strcpyf:
	RCALL SUBOPT_0x1
    ld   r30,y+
    ld   r31,y+
    ld   r26,y+
    ld   r27,y+
    movw r24,r26
strcpyf0:
	lpm  r0,z+
    st   x+,r0
    tst  r0
    brne strcpyf0
    movw r30,r24
    ret
_strlen:
	RCALL SUBOPT_0x1
    ld   r26,y+
    ld   r27,y+
    clr  r30
    clr  r31
strlen0:
    ld   r22,x+
    tst  r22
    breq strlen1
    adiw r30,1
    rjmp strlen0
strlen1:
    ret
_strlenf:
	RCALL SUBOPT_0x1
    clr  r26
    clr  r27
    ld   r30,y+
    ld   r31,y+
strlenf0:
	lpm  r0,z+
    tst  r0
    breq strlenf1
    adiw r26,1
    rjmp strlenf0
strlenf1:
    movw r30,r26
    ret

	.DSEG
_mb:
	.BYTE 0x2
_md:
	.BYTE 0x2
_ac4:
	.BYTE 0x2
_ac5:
	.BYTE 0x2
_ac6:
	.BYTE 0x2
_mc:
	.BYTE 0x4
_UT:
	.BYTE 0x4
_UP:
	.BYTE 0x4
_T:
	.BYTE 0x4
_P:
	.BYTE 0x4
_x1:
	.BYTE 0x4
_x2:
	.BYTE 0x4
_x3:
	.BYTE 0x4
_b3:
	.BYTE 0x4
_b5:
	.BYTE 0x4
_b6:
	.BYTE 0x4
_b4:
	.BYTE 0x4
_b7:
	.BYTE 0x4
_data:
	.BYTE 0x2
_n1:
	.BYTE 0x2
_n2:
	.BYTE 0x2
_temp_t1:
	.BYTE 0x2
_temp_t2:
	.BYTE 0x2
_lcd_buf:
	.BYTE 0x11
__base_y_G101:
	.BYTE 0x4
__lcd_x:
	.BYTE 0x1
__lcd_y:
	.BYTE 0x1
__lcd_maxx:
	.BYTE 0x1
__seed_G103:
	.BYTE 0x4

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x0:
	ST   -Y,R26
	RCALL _i2c_start
	LDI  R26,LOW(238)
	RJMP _i2c_write

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x1:
	ST   -Y,R27
	ST   -Y,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x2:
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 12 TIMES, CODE SIZE REDUCTION:108 WORDS
SUBOPT_0x3:
	RCALL _read_from_device
	LDS  R27,_data
	LDI  R26,LOW(0)
	__GETB1MN _data,1
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES, CODE SIZE REDUCTION:108 WORDS
SUBOPT_0x4:
	RCALL _lcd_clear
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R26,LOW(0)
	RCALL _lcd_gotoxy
	__POINTW2FN _0x0,0
	RCALL _lcd_putsf
	LDI  R30,LOW(_lcd_buf)
	LDI  R31,HIGH(_lcd_buf)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 23 TIMES, CODE SIZE REDUCTION:20 WORDS
SUBOPT_0x5:
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:100 WORDS
SUBOPT_0x6:
	RCALL __CWD1
	RCALL __PUTPARD1
	LDI  R24,4
	RCALL _sprintf
	ADIW R28,8
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R26,LOW(1)
	RCALL _lcd_gotoxy
	LDI  R26,LOW(_lcd_buf)
	LDI  R27,HIGH(_lcd_buf)
	RCALL _lcd_puts
	LDI  R26,LOW(100)
	LDI  R27,0
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:32 WORDS
SUBOPT_0x7:
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	LDI  R24,4
	RCALL _sprintf
	ADIW R28,8
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R26,LOW(1)
	RCALL _lcd_gotoxy
	LDI  R26,LOW(_lcd_buf)
	LDI  R27,HIGH(_lcd_buf)
	RCALL _lcd_puts
	LDI  R26,LOW(100)
	LDI  R27,0
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x8:
	LDS  R30,_ac5
	LDS  R31,_ac5+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x9:
	LDS  R30,_ac6
	LDS  R31,_ac6+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0xA:
	RCALL __CWD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 18 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0xB:
	MOVW R26,R30
	MOVW R24,R22
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0xC:
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0xD:
	LDS  R30,_mc
	LDS  R31,_mc+1
	LDS  R22,_mc+2
	LDS  R23,_mc+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0xE:
	LDI  R30,LOW(0)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0xF:
	LDI  R27,0
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x10:
	LDS  R30,_md
	LDS  R31,_md+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x11:
	RCALL __MULD12
	RJMP SUBOPT_0xB

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x12:
	__GETD1N 0x8000
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:22 WORDS
SUBOPT_0x13:
	RCALL __DIVD21
	STS  _x1,R30
	STS  _x1+1,R31
	STS  _x1+2,R22
	STS  _x1+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:26 WORDS
SUBOPT_0x14:
	LDS  R26,_x1
	LDS  R27,_x1+1
	LDS  R24,_x1+2
	LDS  R25,_x1+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:52 WORDS
SUBOPT_0x15:
	RCALL __DIVD21
	STS  _x2,R30
	STS  _x2+1,R31
	STS  _x2+2,R22
	STS  _x2+3,R23
	RCALL SUBOPT_0x14
	RCALL __ADDD12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x16:
	LDS  R30,_b5
	LDS  R31,_b5+1
	LDS  R22,_b5+2
	LDS  R23,_b5+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x17:
	RCALL SUBOPT_0xB
	__GETD1N 0x10
	RCALL __DIVD21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x18:
	LDS  R26,_T
	LDS  R27,_T+1
	LDS  R24,_T+2
	LDS  R25,_T+3
	__GETD1N 0xA
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x19:
	RCALL __DIVD21
	STS  _n1,R30
	STS  _n1+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x1A:
	RCALL __MODD21
	STS  _n2,R30
	STS  _n2+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x1B:
	LDS  R30,_n1
	LDS  R31,_n1+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x1C:
	LDS  R30,_n2
	LDS  R31,_n2+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x1D:
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x1B
	RCALL SUBOPT_0xA
	RCALL __PUTPARD1
	RCALL SUBOPT_0x1C
	RCALL SUBOPT_0xA
	RCALL __PUTPARD1
	LDI  R24,8
	RCALL _sprintf
	ADIW R28,12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:19 WORDS
SUBOPT_0x1E:
	LDS  R30,_b6
	LDS  R31,_b6+1
	LDS  R22,_b6+2
	LDS  R23,_b6+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x1F:
	LDS  R26,_b6
	LDS  R27,_b6+1
	LDS  R24,_b6+2
	LDS  R25,_b6+3
	RJMP SUBOPT_0x11

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x20:
	__GETD1N 0x1000
	RCALL __DIVD21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x21:
	RCALL __CWD2
	RJMP SUBOPT_0x11

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x22:
	__GETD1N 0x800
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x23:
	STS  _x3,R30
	STS  _x3+1,R31
	STS  _x3+2,R22
	STS  _x3+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x24:
	LDS  R30,_x3
	LDS  R31,_x3+1
	LDS  R22,_x3+2
	LDS  R23,_x3+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x25:
	__ADDD1N 2
	RCALL SUBOPT_0xB
	__GETD1N 0x4
	RCALL __DIVD21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x26:
	__GETD1N 0x10000
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x27:
	LDS  R26,_b7
	LDS  R27,_b7+1
	LDS  R24,_b7+2
	LDS  R25,_b7+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x28:
	LDS  R30,_b4
	LDS  R31,_b4+1
	LDS  R22,_b4+2
	LDS  R23,_b4+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:19 WORDS
SUBOPT_0x29:
	LDS  R26,_P
	LDS  R27,_P+1
	LDS  R24,_P+2
	LDS  R25,_P+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x2A:
	RCALL SUBOPT_0x29
	__GETD1N 0x2710
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x2B:
	__DELAY_USW 200
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x2C:
	RCALL __GETD1S0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x2D:
	LDI  R26,LOW(48)
	RCALL __lcd_write_nibble_G101
	RJMP SUBOPT_0x2B

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x2E:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x2F:
	ADIW R26,4
	RCALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x30:
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x31:
	RCALL SUBOPT_0x1
	SBIW R28,4
	LDI  R30,LOW(0)
	ST   Y,R30
	STD  Y+1,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x32:
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x33:
	MOV  R30,R17
	SUBI R17,1
	CPI  R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:34 WORDS
SUBOPT_0x34:
	__GETD2S 4
	__GETD1N 0x41200000
	RCALL __MULF12
	__PUTD1S 4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x35:
	__GETD1S 12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:22 WORDS
SUBOPT_0x36:
	__GETD1S 4
	__GETD2S 12
	RCALL __CMPF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x37:
	__GETD2S 12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x38:
	__GETD1N 0x3DCCCCCD
	RCALL __MULF12
	__PUTD1S 12
	SUBI R19,-LOW(1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x39:
	__GETD1N 0x41200000
	RCALL __MULF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x3A:
	__PUTD1S 12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x3B:
	__GETD2N 0x3F000000
	RCALL __ADDF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x3C:
	__GETD2S 4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x3D:
	__GETD1N 0x3DCCCCCD
	RCALL __MULF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x3E:
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	ADIW R26,1
	STD  Y+8,R26
	STD  Y+8+1,R27
	SBIW R26,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x3F:
	MOV  R30,R16
	SUBI R30,-LOW(48)
	ST   X,R30
	MOV  R30,R16
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x40:
	RCALL SUBOPT_0x32
	ADIW R30,1
	STD  Y+8,R30
	STD  Y+8+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x41:
	SBIW R30,1
	MOVW R22,R30
	MOV  R26,R19
	LDI  R30,LOW(10)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x42:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:18 WORDS
SUBOPT_0x43:
	ST   -Y,R18
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	LDD  R30,Y+9
	LDD  R31,Y+9+1
	ICALL
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:33 WORDS
SUBOPT_0x44:
	__GETW1SX 90
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:28 WORDS
SUBOPT_0x45:
	SBIW R30,4
	__PUTW1SX 90
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x46:
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	LDD  R30,Y+9
	LDD  R31,Y+9+1
	ICALL
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x47:
	MOVW R30,R28
	ADIW R30,22
	STD  Y+14,R30
	STD  Y+14+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:23 WORDS
SUBOPT_0x48:
	__GETW2SX 90
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x49:
	__PUTD1S 10
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x4A:
	RCALL SUBOPT_0x44
	RJMP SUBOPT_0x45

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x4B:
	__GETD1S 10
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x4C:
	STD  Y+14,R30
	STD  Y+14+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x4D:
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	RCALL _strlen
	MOV  R17,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x4E:
	RCALL SUBOPT_0x48
	RJMP SUBOPT_0x2F

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x4F:
	__PUTD1S 16
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:14 WORDS
SUBOPT_0x50:
	ANDI R16,LOW(251)
	LDD  R30,Y+21
	ST   -Y,R30
	__GETW2SX 87
	__GETW1SX 89
	ICALL
	CPI  R21,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x51:
	__GETD1S 16
	__GETD2S 10
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x52:
	__GETD2S 16
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x53:
	MOVW R26,R28
	ADIW R26,12
	RCALL __ADDW2R15
	RCALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x54:
	__GETD1S 9
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x55:
	__PUTD1S 9
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:14 WORDS
SUBOPT_0x56:
	RCALL SUBOPT_0x42
	ADIW R26,1
	STD  Y+6,R26
	STD  Y+6+1,R27
	SBIW R26,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x57:
	__GETD2S 2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x58:
	__PUTD1S 2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x59:
	__GETD1S 2
	__GETD2S 9
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x5A:
	__GETD2S 9
	RET


	.CSEG
	.equ __i2c_dir=__i2c_port-1
	.equ __i2c_pin=__i2c_port-2

_i2c_init:
	cbi  __i2c_port,__scl_bit
	cbi  __i2c_port,__sda_bit
	sbi  __i2c_dir,__scl_bit
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_delay2
_i2c_start:
	cbi  __i2c_dir,__sda_bit
	cbi  __i2c_dir,__scl_bit
	clr  r30
	nop
	sbis __i2c_pin,__sda_bit
	ret
	sbis __i2c_pin,__scl_bit
	ret
	rcall __i2c_delay1
	sbi  __i2c_dir,__sda_bit
	rcall __i2c_delay1
	sbi  __i2c_dir,__scl_bit
	ldi  r30,1
__i2c_delay1:
	ldi  r22,13
	rjmp __i2c_delay2l
_i2c_stop:
	sbi  __i2c_dir,__sda_bit
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__sda_bit
__i2c_delay2:
	ldi  r22,27
__i2c_delay2l:
	dec  r22
	brne __i2c_delay2l
	ret
_i2c_read:
	ldi  r23,8
__i2c_read0:
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
__i2c_read3:
	sbis __i2c_pin,__scl_bit
	rjmp __i2c_read3
	rcall __i2c_delay1
	clc
	sbic __i2c_pin,__sda_bit
	sec
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	rol  r30
	dec  r23
	brne __i2c_read0
	mov  r23,r26
	tst  r23
	brne __i2c_read1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_read2
__i2c_read1:
	sbi  __i2c_dir,__sda_bit
__i2c_read2:
	rcall __i2c_delay1
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_delay1

_i2c_write:
	ldi  r23,8
__i2c_write0:
	lsl  r26
	brcc __i2c_write1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_write2
__i2c_write1:
	sbi  __i2c_dir,__sda_bit
__i2c_write2:
	rcall __i2c_delay2
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
__i2c_write3:
	sbis __i2c_pin,__scl_bit
	rjmp __i2c_write3
	rcall __i2c_delay1
	sbi  __i2c_dir,__scl_bit
	dec  r23
	brne __i2c_write0
	cbi  __i2c_dir,__sda_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	ldi  r30,1
	sbic __i2c_pin,__sda_bit
	clr  r30
	sbi  __i2c_dir,__scl_bit
	rjmp __i2c_delay1

_delay_ms:
	adiw r26,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r26,1
	brne __delay_ms0
__delay_ms1:
	ret

__ANEGF1:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __ANEGF10
	SUBI R23,0x80
__ANEGF10:
	RET

__ROUND_REPACK:
	TST  R21
	BRPL __REPACK
	CPI  R21,0x80
	BRNE __ROUND_REPACK0
	SBRS R30,0
	RJMP __REPACK
__ROUND_REPACK0:
	ADIW R30,1
	ADC  R22,R25
	ADC  R23,R25
	BRVS __REPACK1

__REPACK:
	LDI  R21,0x80
	EOR  R21,R23
	BRNE __REPACK0
	PUSH R21
	RJMP __ZERORES
__REPACK0:
	CPI  R21,0xFF
	BREQ __REPACK1
	LSL  R22
	LSL  R0
	ROR  R21
	ROR  R22
	MOV  R23,R21
	RET
__REPACK1:
	PUSH R21
	TST  R0
	BRMI __REPACK2
	RJMP __MAXRES
__REPACK2:
	RJMP __MINRES

__UNPACK:
	LDI  R21,0x80
	MOV  R1,R25
	AND  R1,R21
	LSL  R24
	ROL  R25
	EOR  R25,R21
	LSL  R21
	ROR  R24

__UNPACK1:
	LDI  R21,0x80
	MOV  R0,R23
	AND  R0,R21
	LSL  R22
	ROL  R23
	EOR  R23,R21
	LSL  R21
	ROR  R22
	RET

__CFD1U:
	SET
	RJMP __CFD1U0
__CFD1:
	CLT
__CFD1U0:
	PUSH R21
	RCALL __UNPACK1
	CPI  R23,0x80
	BRLO __CFD10
	CPI  R23,0xFF
	BRCC __CFD10
	RJMP __ZERORES
__CFD10:
	LDI  R21,22
	SUB  R21,R23
	BRPL __CFD11
	NEG  R21
	CPI  R21,8
	BRTC __CFD19
	CPI  R21,9
__CFD19:
	BRLO __CFD17
	SER  R30
	SER  R31
	SER  R22
	LDI  R23,0x7F
	BLD  R23,7
	RJMP __CFD15
__CFD17:
	CLR  R23
	TST  R21
	BREQ __CFD15
__CFD18:
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R23
	DEC  R21
	BRNE __CFD18
	RJMP __CFD15
__CFD11:
	CLR  R23
__CFD12:
	CPI  R21,8
	BRLO __CFD13
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R23
	SUBI R21,8
	RJMP __CFD12
__CFD13:
	TST  R21
	BREQ __CFD15
__CFD14:
	LSR  R23
	ROR  R22
	ROR  R31
	ROR  R30
	DEC  R21
	BRNE __CFD14
__CFD15:
	TST  R0
	BRPL __CFD16
	RCALL __ANEGD1
__CFD16:
	POP  R21
	RET

__CDF1U:
	SET
	RJMP __CDF1U0
__CDF1:
	CLT
__CDF1U0:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __CDF10
	CLR  R0
	BRTS __CDF11
	TST  R23
	BRPL __CDF11
	COM  R0
	RCALL __ANEGD1
__CDF11:
	MOV  R1,R23
	LDI  R23,30
	TST  R1
__CDF12:
	BRMI __CDF13
	DEC  R23
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R1
	RJMP __CDF12
__CDF13:
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R1
	PUSH R21
	RCALL __REPACK
	POP  R21
__CDF10:
	RET

__SWAPACC:
	PUSH R20
	MOVW R20,R30
	MOVW R30,R26
	MOVW R26,R20
	MOVW R20,R22
	MOVW R22,R24
	MOVW R24,R20
	MOV  R20,R0
	MOV  R0,R1
	MOV  R1,R20
	POP  R20
	RET

__UADD12:
	ADD  R30,R26
	ADC  R31,R27
	ADC  R22,R24
	RET

__NEGMAN1:
	COM  R30
	COM  R31
	COM  R22
	SUBI R30,-1
	SBCI R31,-1
	SBCI R22,-1
	RET

__SUBF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R25,0x80
	BREQ __ADDF129
	LDI  R21,0x80
	EOR  R1,R21

	RJMP __ADDF120

__ADDF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R25,0x80
	BREQ __ADDF129

__ADDF120:
	CPI  R23,0x80
	BREQ __ADDF128
__ADDF121:
	MOV  R21,R23
	SUB  R21,R25
	BRVS __ADDF1211
	BRPL __ADDF122
	RCALL __SWAPACC
	RJMP __ADDF121
__ADDF122:
	CPI  R21,24
	BRLO __ADDF123
	CLR  R26
	CLR  R27
	CLR  R24
__ADDF123:
	CPI  R21,8
	BRLO __ADDF124
	MOV  R26,R27
	MOV  R27,R24
	CLR  R24
	SUBI R21,8
	RJMP __ADDF123
__ADDF124:
	TST  R21
	BREQ __ADDF126
__ADDF125:
	LSR  R24
	ROR  R27
	ROR  R26
	DEC  R21
	BRNE __ADDF125
__ADDF126:
	MOV  R21,R0
	EOR  R21,R1
	BRMI __ADDF127
	RCALL __UADD12
	BRCC __ADDF129
	ROR  R22
	ROR  R31
	ROR  R30
	INC  R23
	BRVC __ADDF129
	RJMP __MAXRES
__ADDF128:
	RCALL __SWAPACC
__ADDF129:
	RCALL __REPACK
	POP  R21
	RET
__ADDF1211:
	BRCC __ADDF128
	RJMP __ADDF129
__ADDF127:
	SUB  R30,R26
	SBC  R31,R27
	SBC  R22,R24
	BREQ __ZERORES
	BRCC __ADDF1210
	COM  R0
	RCALL __NEGMAN1
__ADDF1210:
	TST  R22
	BRMI __ADDF129
	LSL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVC __ADDF1210

__ZERORES:
	CLR  R30
	CLR  R31
	CLR  R22
	CLR  R23
	POP  R21
	RET

__MINRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	SER  R23
	POP  R21
	RET

__MAXRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	LDI  R23,0x7F
	POP  R21
	RET

__MULF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BREQ __ZERORES
	CPI  R25,0x80
	BREQ __ZERORES
	EOR  R0,R1
	SEC
	ADC  R23,R25
	BRVC __MULF124
	BRLT __ZERORES
__MULF125:
	TST  R0
	BRMI __MINRES
	RJMP __MAXRES
__MULF124:
	PUSH R0
	PUSH R17
	PUSH R18
	PUSH R19
	PUSH R20
	CLR  R17
	CLR  R18
	CLR  R25
	MUL  R22,R24
	MOVW R20,R0
	MUL  R24,R31
	MOV  R19,R0
	ADD  R20,R1
	ADC  R21,R25
	MUL  R22,R27
	ADD  R19,R0
	ADC  R20,R1
	ADC  R21,R25
	MUL  R24,R30
	RCALL __MULF126
	MUL  R27,R31
	RCALL __MULF126
	MUL  R22,R26
	RCALL __MULF126
	MUL  R27,R30
	RCALL __MULF127
	MUL  R26,R31
	RCALL __MULF127
	MUL  R26,R30
	ADD  R17,R1
	ADC  R18,R25
	ADC  R19,R25
	ADC  R20,R25
	ADC  R21,R25
	MOV  R30,R19
	MOV  R31,R20
	MOV  R22,R21
	MOV  R21,R18
	POP  R20
	POP  R19
	POP  R18
	POP  R17
	POP  R0
	TST  R22
	BRMI __MULF122
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	RJMP __MULF123
__MULF122:
	INC  R23
	BRVS __MULF125
__MULF123:
	RCALL __ROUND_REPACK
	POP  R21
	RET

__MULF127:
	ADD  R17,R0
	ADC  R18,R1
	ADC  R19,R25
	RJMP __MULF128
__MULF126:
	ADD  R18,R0
	ADC  R19,R1
__MULF128:
	ADC  R20,R25
	ADC  R21,R25
	RET

__DIVF21:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BRNE __DIVF210
	TST  R1
__DIVF211:
	BRPL __DIVF219
	RJMP __MINRES
__DIVF219:
	RJMP __MAXRES
__DIVF210:
	CPI  R25,0x80
	BRNE __DIVF218
__DIVF217:
	RJMP __ZERORES
__DIVF218:
	EOR  R0,R1
	SEC
	SBC  R25,R23
	BRVC __DIVF216
	BRLT __DIVF217
	TST  R0
	RJMP __DIVF211
__DIVF216:
	MOV  R23,R25
	PUSH R17
	PUSH R18
	PUSH R19
	PUSH R20
	CLR  R1
	CLR  R17
	CLR  R18
	CLR  R19
	CLR  R20
	CLR  R21
	LDI  R25,32
__DIVF212:
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	CPC  R20,R17
	BRLO __DIVF213
	SUB  R26,R30
	SBC  R27,R31
	SBC  R24,R22
	SBC  R20,R17
	SEC
	RJMP __DIVF214
__DIVF213:
	CLC
__DIVF214:
	ROL  R21
	ROL  R18
	ROL  R19
	ROL  R1
	ROL  R26
	ROL  R27
	ROL  R24
	ROL  R20
	DEC  R25
	BRNE __DIVF212
	MOVW R30,R18
	MOV  R22,R1
	POP  R20
	POP  R19
	POP  R18
	POP  R17
	TST  R22
	BRMI __DIVF215
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVS __DIVF217
__DIVF215:
	RCALL __ROUND_REPACK
	POP  R21
	RET

__CMPF12:
	TST  R25
	BRMI __CMPF120
	TST  R23
	BRMI __CMPF121
	CP   R25,R23
	BRLO __CMPF122
	BRNE __CMPF121
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	BRLO __CMPF122
	BREQ __CMPF123
__CMPF121:
	CLZ
	CLC
	RET
__CMPF122:
	CLZ
	SEC
	RET
__CMPF123:
	SEZ
	CLC
	RET
__CMPF120:
	TST  R23
	BRPL __CMPF122
	CP   R25,R23
	BRLO __CMPF121
	BRNE __CMPF122
	CP   R30,R26
	CPC  R31,R27
	CPC  R22,R24
	BRLO __CMPF122
	BREQ __CMPF123
	RJMP __CMPF121

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ADDD12:
	ADD  R30,R26
	ADC  R31,R27
	ADC  R22,R24
	ADC  R23,R25
	RET

__ADDD21:
	ADD  R26,R30
	ADC  R27,R31
	ADC  R24,R22
	ADC  R25,R23
	RET

__SUBD12:
	SUB  R30,R26
	SBC  R31,R27
	SBC  R22,R24
	SBC  R23,R25
	RET

__SUBD21:
	SUB  R26,R30
	SBC  R27,R31
	SBC  R24,R22
	SBC  R25,R23
	RET

__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__ANEGD1:
	COM  R31
	COM  R22
	COM  R23
	NEG  R30
	SBCI R31,-1
	SBCI R22,-1
	SBCI R23,-1
	RET

__LSLW2:
	LSL  R30
	ROL  R31
	LSL  R30
	ROL  R31
	RET

__LSLD1:
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R23
	RET

__CBD1:
	MOV  R31,R30
	ADD  R31,R31
	SBC  R31,R31
	MOV  R22,R31
	MOV  R23,R31
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__CWD2:
	MOV  R24,R27
	ADD  R24,R24
	SBC  R24,R24
	MOV  R25,R24
	RET

__MULW12U:
	MUL  R31,R26
	MOV  R31,R0
	MUL  R30,R27
	ADD  R31,R0
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	RET

__MULD12U:
	MUL  R23,R26
	MOV  R23,R0
	MUL  R22,R27
	ADD  R23,R0
	MUL  R31,R24
	ADD  R23,R0
	MUL  R30,R25
	ADD  R23,R0
	MUL  R22,R26
	MOV  R22,R0
	ADD  R23,R1
	MUL  R31,R27
	ADD  R22,R0
	ADC  R23,R1
	MUL  R30,R24
	ADD  R22,R0
	ADC  R23,R1
	CLR  R24
	MUL  R31,R26
	MOV  R31,R0
	ADD  R22,R1
	ADC  R23,R24
	MUL  R30,R27
	ADD  R31,R0
	ADC  R22,R1
	ADC  R23,R24
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	ADC  R22,R24
	ADC  R23,R24
	RET

__MULW12:
	RCALL __CHKSIGNW
	RCALL __MULW12U
	BRTC __MULW121
	RCALL __ANEGW1
__MULW121:
	RET

__MULD12:
	RCALL __CHKSIGND
	RCALL __MULD12U
	BRTC __MULD121
	RCALL __ANEGD1
__MULD121:
	RET

__DIVB21U:
	CLR  R0
	LDI  R25,8
__DIVB21U1:
	LSL  R26
	ROL  R0
	SUB  R0,R30
	BRCC __DIVB21U2
	ADD  R0,R30
	RJMP __DIVB21U3
__DIVB21U2:
	SBR  R26,1
__DIVB21U3:
	DEC  R25
	BRNE __DIVB21U1
	MOV  R30,R26
	MOV  R26,R0
	RET

__DIVB21:
	RCALL __CHKSIGNB
	RCALL __DIVB21U
	BRTC __DIVB211
	NEG  R30
__DIVB211:
	RET

__DIVD21U:
	PUSH R19
	PUSH R20
	PUSH R21
	CLR  R0
	CLR  R1
	CLR  R20
	CLR  R21
	LDI  R19,32
__DIVD21U1:
	LSL  R26
	ROL  R27
	ROL  R24
	ROL  R25
	ROL  R0
	ROL  R1
	ROL  R20
	ROL  R21
	SUB  R0,R30
	SBC  R1,R31
	SBC  R20,R22
	SBC  R21,R23
	BRCC __DIVD21U2
	ADD  R0,R30
	ADC  R1,R31
	ADC  R20,R22
	ADC  R21,R23
	RJMP __DIVD21U3
__DIVD21U2:
	SBR  R26,1
__DIVD21U3:
	DEC  R19
	BRNE __DIVD21U1
	MOVW R30,R26
	MOVW R22,R24
	MOVW R26,R0
	MOVW R24,R20
	POP  R21
	POP  R20
	POP  R19
	RET

__DIVD21:
	RCALL __CHKSIGND
	RCALL __DIVD21U
	BRTC __DIVD211
	RCALL __ANEGD1
__DIVD211:
	RET

__MODB21:
	CLT
	SBRS R26,7
	RJMP __MODB211
	NEG  R26
	SET
__MODB211:
	SBRC R30,7
	NEG  R30
	RCALL __DIVB21U
	MOV  R30,R26
	BRTC __MODB212
	NEG  R30
__MODB212:
	RET

__MODD21U:
	RCALL __DIVD21U
	MOVW R30,R26
	MOVW R22,R24
	RET

__MODD21:
	CLT
	SBRS R25,7
	RJMP __MODD211
	COM  R26
	COM  R27
	COM  R24
	COM  R25
	SUBI R26,-1
	SBCI R27,-1
	SBCI R24,-1
	SBCI R25,-1
	SET
__MODD211:
	SBRC R23,7
	RCALL __ANEGD1
	RCALL __DIVD21U
	MOVW R30,R26
	MOVW R22,R24
	BRTC __MODD212
	RCALL __ANEGD1
__MODD212:
	RET

__CHKSIGNB:
	CLT
	SBRS R30,7
	RJMP __CHKSB1
	NEG  R30
	SET
__CHKSB1:
	SBRS R26,7
	RJMP __CHKSB2
	NEG  R26
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSB2:
	RET

__CHKSIGNW:
	CLT
	SBRS R31,7
	RJMP __CHKSW1
	RCALL __ANEGW1
	SET
__CHKSW1:
	SBRS R27,7
	RJMP __CHKSW2
	COM  R26
	COM  R27
	ADIW R26,1
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSW2:
	RET

__CHKSIGND:
	CLT
	SBRS R23,7
	RJMP __CHKSD1
	RCALL __ANEGD1
	SET
__CHKSD1:
	SBRS R25,7
	RJMP __CHKSD2
	CLR  R0
	COM  R26
	COM  R27
	COM  R24
	COM  R25
	ADIW R26,1
	ADC  R24,R0
	ADC  R25,R0
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSD2:
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETD1P:
	LD   R30,X+
	LD   R31,X+
	LD   R22,X+
	LD   R23,X
	SBIW R26,3
	RET

__GETD1S0:
	LD   R30,Y
	LDD  R31,Y+1
	LDD  R22,Y+2
	LDD  R23,Y+3
	RET

__GETD2S0:
	LD   R26,Y
	LDD  R27,Y+1
	LDD  R24,Y+2
	LDD  R25,Y+3
	RET

__PUTD1S0:
	ST   Y,R30
	STD  Y+1,R31
	STD  Y+2,R22
	STD  Y+3,R23
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__PUTPARD2:
	ST   -Y,R25
	ST   -Y,R24
	ST   -Y,R27
	ST   -Y,R26
	RET

__SWAPD12:
	MOV  R1,R24
	MOV  R24,R22
	MOV  R22,R1
	MOV  R1,R25
	MOV  R25,R23
	MOV  R23,R1

__SWAPW12:
	MOV  R1,R27
	MOV  R27,R31
	MOV  R31,R1

__SWAPB12:
	MOV  R1,R26
	MOV  R26,R30
	MOV  R30,R1
	RET

__CPD10:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

;END OF CODE MARKER
__END_OF_CODE:
